############################################################################
# Unified Plone installer build script
# ZEO Cluster builder.
# Original Author: Kamal Gill (kamalgill at mac.com)
# Adapted for Plone 3 and buildout by Steve McMahon (steve at dcn.org)
#
# $LastChangedDate: 2008-09-07 09:09:09 -0700 (Sun, 07 Sep 2008) $ $LastChangedRevision: 22465M $

cd $CWD

echo "Copying ZEO Cluster buildout template"
cp -r base_skeleton $ZEOCLUSTER_HOME
cp buildout_templates/cluster.cfg $ZEOCLUSTER_HOME/buildout.cfg
BOC=$ZEOCLUSTER_HOME/buildout.cfg
BBIN=$ZEOCLUSTER_HOME/bin/buildout

# patch password
# and buildout cache location
mv $BOC ${BOC}.bak
sed -e "s|__PASSWORD__|$PASSWORD|" \
    -e "s|__TARGET__|$PLONE_HOME|" \
    ${BOC}.bak \
    > $BOC
rm $BOC.bak

# Set effective-user
mv $BOC ${BOC}.bak
if [ $ROOT_INSTALL -eq 1 ]
then
    sed -e "s|#effective-user = __EFFECTIVE_USER__|effective-user = $EFFECTIVE_USER|" \
        -e "s|#effective-user = __ZEO_USER__|effective-user = $ZEO_USER|" \
        -e "s|sudo-command = |sudo-command = sudo|" \
        ${BOC}.bak \
        > $BOC
else
    sed -e "s|^ *chown -R.*$||" \
        -e "s|^ *find .*$||" \
        ${BOC}.bak \
        > $BOC
fi
rm $BOC.bak

if [ $SEPARATE_ZOPE -eq 1 ]
then
   # patch buildout.cfg to use the separate zope
    mv $BOC ${BOC}.bak
    sed -e "s|    zope2|#    zope2|" \
        -e "s|\\$.zope2:location.|$MYZOPE|" \
        -e "s|\[zope2\]|#[zope2]|" \
        -e "s|recipe = plone.recipe.zope2install|#recipe = plone.recipe.zope2install|" \
        -e "s|url = \\$.plone:zope2-url.|#url = \\$\\{plone:zope2-url\\}|" \
        ${BOC}.bak \
        > $BOC
    rm $BOC.bak
fi

# patch bin/buildout paths
mv $BBIN ${BBIN}.bak
sed "s|__TARGET__|$PLONE_HOME|" ${BBIN}.bak > $BBIN
rm $BBIN.bak
chmod 755 $BBIN

chmod 600 $ZEOCLUSTER_HOME/buildout.cfg

# remove OS X and svn detritus (this is mainly helpful for installer development)
find $ZEOCLUSTER_HOME -name "._*" -exec rm {} \; > /dev/null
find $ZEOCLUSTER_HOME -name ".svn" | xargs rm -rf

if [ $RUN_BUILDOUT -eq 1 ]
then
    echo "Running buildout"
    cd $ZEOCLUSTER_HOME
    bin/buildout -No
    
    if [ ! -e bin/zeoserver ] || [ ! -e bin/client1 ] || [ ! -e parts/plone ] || [ ! -e var ]
    then
        echo "Parts of the install are missing. Buildout must have failed. Aborting."
        exit 1
    fi
else
    echo "Skipping bin/buildout at your request."
fi

